SystemOrganization addCategory: #'Zodiac-Extra'!

POP3Client subclass: #ZdcSecurePOP3Client
	instanceVariableNames: 'lineReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zodiac-Extra'!

!ZdcSecurePOP3Client commentStamp: 'SvenVanCaekenberghe 12/6/2011 12:46' prior: 0!
I am ZdcSecurePOP3Client.

I open a ZdcSecureSocketStream to the POP3 server and connect it at the SSL level.

ZdcSecurePOP3Client
	retrieveMessagesFromGMailAccount: '<your-name>@gmail.com'
	password: '<your-password>'
	limit: 5.!

!ZdcSecurePOP3Client classSide methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 12/6/2011 12:01'!
defaultPortForSSL
	^ 995! !

!ZdcSecurePOP3Client classSide methodsFor: 'example' stamp: 'SvenVanCaekenberghe 12/6/2011 12:51'!
retrieveMessagesFromGMailAccount: accountAddress password: password limit: limit
	| pop3Client messages messageCount |
	(pop3Client := self openOnHostNamed: 'smtp.gmail.com' port: self defaultPortForSSL)
		loginUser: accountAddress password: password.
	messages := OrderedCollection new.
	messageCount := pop3Client messageCount.
	messageCount to: ((messageCount - limit) max: 0) + 1 by: -1 do: [ :each |
		messages add: (pop3Client retrieveMessage: each) ].
	pop3Client
		quit;
		close.
	^ messages
! !

!ZdcSecurePOP3Client methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/6/2011 11:51'!
ensureConnection
	"Overwritten & refactored"
		
	self isConnected ifTrue: [ ^ self ].
	self stream ifNotNil: [ self stream close ].

	self setupStream.
	self checkResponse.
	self login! !

!ZdcSecurePOP3Client methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/6/2011 12:25'!
fetchNextResponse
	self lastResponse: self nextLineFromStream! !

!ZdcSecurePOP3Client methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/6/2011 12:42'!
getMultilineResponse
	"Get a multiple line response to the last command, filtering out LF characters. 
	A multiple line response ends with a line containing only a single period (.) character."

	| response done chunk |
	response := String new writeStream.
	done := false.
	[ done ] whileFalse: [
		chunk := self nextLineFromStream.
		(chunk beginsWith: '.')
			ifTrue: [ response nextPutAll: (chunk copyFrom: 2 to: chunk size); cr ]
			ifFalse: [ response nextPutAll: chunk; cr ].
		done := (chunk = '.') ].
	^ response contents
! !

!ZdcSecurePOP3Client methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/7/2011 21:06'!
logVerbose: aString
	"self log: aString; log: Character cr"! !

!ZdcSecurePOP3Client methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:02'!
nextLineFromStream
	| line |
	line := lineReader nextLine.
	self logVerbose: line.
	^ line! !

!ZdcSecurePOP3Client methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:12'!
sendCommand: aString
	self logVerbose: aString.
	self stream 
		nextPutAll: aString;
		nextPutAll: #[13 10];
		flush
! !

!ZdcSecurePOP3Client methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/6/2011 11:52'!
setupStream
	self setupStreamForSSL! !

!ZdcSecurePOP3Client methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/7/2011 21:04'!
setupStreamForSSL
	self stream: (ZdcSecureSocketStream openConnectionToHost: self host port: self port).
	self stream connect.
	self logVerbose: 'SSL Connect OK.'! !

!ZdcSecurePOP3Client methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/7/2011 21:00'!
stream: aStream
	super stream: aStream.
	lineReader := ZnLineReader on: self stream! !

SMTPClient subclass: #ZdcSecureSMTPClient
	instanceVariableNames: 'variant lineReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zodiac-Extra'!

!ZdcSecureSMTPClient commentStamp: 'SvenVanCaekenberghe 12/6/2011 11:46' prior: 0!
I am ZdcSecureSMTPClient.

I open a ZdcSecureSocketStream to the SMTP server and connect it at the SSL level.

| mailMessage |
mailMessage := MailMessage empty.
mailMessage setField: 'subject' toString: 'ZdcSecureSMTPClient Test'.
mailMessage body: (MIMEDocument contentType: 'text/plain' content: 'This is test from Pharo Smalltalk').
ZdcSecureSMTPClient
	sendUsingGMailAccount: '<your-name>@gmail.com' 
	password: '<your-password>'
	to: '<email-address>' 
	message: mailMessage!

!ZdcSecureSMTPClient classSide methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 12/5/2011 20:10'!
defaultPortForSSL
	^ 465! !

!ZdcSecureSMTPClient classSide methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 12/5/2011 20:10'!
defaultPortForStartTLS
	^ 587! !

!ZdcSecureSMTPClient classSide methodsFor: 'example' stamp: 'SvenVanCaekenberghe 12/6/2011 13:10'!
sendUsingGMailAccount: senderAddress password: password to: receiverAddress message: mailMessage
	| smtpClient |
	(smtpClient := self new)
		user: senderAddress; 
		password: password.
	smtpClient openOnHost: (NetNameResolver addressForName: 'smtp.gmail.com') port: 465.
	mailMessage setField: 'from' toString: senderAddress.
	mailMessage setField: 'to' toString: receiverAddress.
	^ smtpClient 
		mailFrom: senderAddress to: { receiverAddress } text: mailMessage text;
		quit; 
		close;
		yourself
! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/6/2011 11:50'!
alternativeLogin
	self initiateSession. "send EHLO first"
	self user ifNil: [ ^ self ].
	self sendCommand: 'AUTH LOGIN'.
	self checkResponse.
	self sendCommand: (self encodeString: self user).
	self checkResponse.
	self sendCommand: (self encodeString: self password).
	self checkResponse! !

!ZdcSecureSMTPClient methodsFor: 'private' stamp: 'NorbertHartl 3/27/2012 16:44'!
ensureConnection
	"Overwritten & refactored"
		
	self isConnected ifTrue: [ ^ self].
	self stream ifNotNil: [ self stream close ].
	self setupStream.
	"regarding RFC2487-5.2 the state after SSL negotiation is to be reset to the state after the
	220 server greeting. EHLO command is next which is issued in the following login method  "
	self login! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:14'!
fetchNextResponse
	"The FTP and similar protocols allow multi-line responses.
	If the response is multi-line, the fourth character of the first line is a  
	$- and the last line repeats the numeric code but the code is followed by 
	a space."

	| response result firstLine |
	result := '' writeStream.
	firstLine := self nextLineFromStream.
	result nextPutAll: firstLine.
	(self responseIsContinuation: firstLine) 
		ifTrue: [
			"continued over multiple lines. Discard continuation lines."
			[response := self nextLineFromStream.
			response ifNil: [ ^ nil ].
			response size > 3 and: 
					[ (response copyFrom: 1 to: 3) = (firstLine copyFrom: 1 to: 3) 
						and: [ (response at: 4) = Character space ] ] ] whileFalse: [
							result cr; nextPutAll: response ] ].
	self lastResponse: result contents! !

!ZdcSecureSMTPClient methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 12/5/2011 20:13'!
initialize
	super initialize.
	self useSSL! !

!ZdcSecureSMTPClient methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 12/5/2011 20:12'!
isSSL
	^ variant = #ssl! !

!ZdcSecureSMTPClient methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 12/5/2011 20:12'!
isStartTLS
	^ variant = #startTLS! !

!ZdcSecureSMTPClient methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/7/2011 21:16'!
logVerbose: aString
	"self log: aString; log: Character cr"! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:12'!
nextLineFromStream
	| line |
	line := lineReader nextLine.
	self logVerbose: line.
	^ line! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 9/22/2011 09:05'!
requireStartTLS
	(self lastResponse includesSubString: 'STARTTLS')
		ifFalse: [ ^ self error: 'Server does not seem to support STARTTLS' ].
! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:12'!
sendCommand: aString
	self logVerbose: aString.
	self stream 
		nextPutAll: aString;
		nextPutAll: #[13 10];
		flush
! !

!ZdcSecureSMTPClient methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/5/2011 20:21'!
setupStream
	variant = #ssl ifTrue: [ ^ self setupStreamForSSL ].
	variant = #startTLS ifTrue: [ ^ self setupStreamForStartTLS ]! !

!ZdcSecureSMTPClient methodsFor: 'private' stamp: 'NorbertHartl 3/27/2012 16:38'!
setupStreamForSSL
	self stream: (ZdcSecureSocketStream openConnectionToHost: self host port: self port).
	self stream connect.
	self logVerbose: 'SSL Connect OK.'.
	"as we connect directly with SSL the first message will be a 220 server greeting"
	self checkResponse.
! !

!ZdcSecureSMTPClient methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/5/2011 20:14'!
setupStreamForStartTLS
	"See http://www.ietf.org/rfc/rfc3207.txt for how to setup a secure connection"

	self stream: (SocketStream openConnectionToHost: self host port: self port).
	self checkResponse.
	self initiateSession.
	self requireStartTLS.
	self startTLS! !

!ZdcSecureSMTPClient methodsFor: 'private protocol' stamp: 'SvenVanCaekenberghe 12/7/2011 21:12'!
startTLS
	"Send a STARTTLS command and after the response, 
	switch to a SecureSocketStream and do the client handshake"
	
	self sendCommand: 'STARTTLS'.
	self checkResponse.	
	self stream: (ZdcSecureSocketStream on: self stream socket).
	self stream connect.
	self logVerbose: 'SSL Connect OK.'! !

!ZdcSecureSMTPClient methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/7/2011 21:11'!
stream: aStream
	super stream: aStream.
	lineReader := ZnLineReader on: self stream! !

!ZdcSecureSMTPClient methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 12/5/2011 20:11'!
useSSL
	variant := #ssl! !

!ZdcSecureSMTPClient methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 12/5/2011 20:11'!
useStartTLS
	variant := #startTLS! !
